sub print_hash($$);

sub print_hash($$) {
    my $entry = shift;
    my $depth = shift;
    if (ref($entry) eq "HASH") {
        my %hash = %{$entry};

        foreach $key (keys %hash) {
            print " "x$depth."$key => \n";
            print_hash($hash{$key},$depth + 2);
        }
    } elsif (ref($entry) eq "ARRAY") {
        my @array = @{$entry};
        my $i = 0;
        for ($i = 0; $i <= $#array; $i++) {
            print " "x$depth,"$i\n";
            print_hash($array[$i],$depth + 2);
        }
    } else {
        print " "x$depth;
        if (defined($entry)) {
            print "$entry\n";
        } else {
            print "*[UNDEFINED]*\n";
        }
    }

}

1;
